<template>
  <div ref="div">
    <canvas ref="canvas" :width="width" :height="height" id="graph" />
  </div>
</template>

<script>
import * as d3 from "d3";
import lasso from "@/util/lasso";

export default {
  props: {
    width: {
      type: Number,
      required: true
    },
    height: {
      type: Number,
      required: true
    },
    data: Object,
    dark: Boolean,
    selectedNodes: Array,
    zoomSelectionNodes: Array,
    isZoomed: Boolean
  },

  data() {
    return {
      canvas: null,
      context: null,
      selection: null,
      simulation: null,
      vEdges: null,
      transform: d3.zoomIdentity,
      color: d3.scaleOrdinal(d3.schemeCategory10),
      nodeLinkedEdges: null,
      linkedByIndexUpdate: {},
      visibilityVar: 1,
      maxDegree: 0,
      selectedPoints: [],
      hoverNode: null,
      mouseMovingFrequency: 0,
      lassoInstance: null,
      sortArray: [],
      startDegree: 1
    };
  },

  watch: {
    dark: function() {
      this.tick();
    },
    width: function() {
      this.tick();
    },
    height: function() {
      this.tick();
    },
    data: function() {
      this.tick();
    },
    selectedNodes: function() {
      this.tick();
    },
    isZoomed: function() {
      this.setVisibleEdges();
      this.tick();
    }
  },

  computed: {
    nodes() {
      if (this.zoomSelectionNodes.length == 0) {
        return this.data.graph ? this.data.graph.nodes : [];
      } else {
        return this.data.graph.nodes.filter(d => {
          if (this.zoomSelectionNodes.includes(d.id)) {
            return true;
          } else {
            return false;
          }
        });
      }
    },
    links() {
      if (this.zoomSelectionNodes.length == 0) {
        return this.data.graph ? this.data.graph.links : [];
      } else {
        return this.data.graph.links.filter(d => {
          if (
            this.zoomSelectionNodes.includes(d.source.id) &&
            this.zoomSelectionNodes.includes(d.target.id)
          ) {
            return true;
          } else {
            return false;
          }
        });
      }
    },
    lineWidth() {
      if (this.links.length < 10000) {
        return 1;
      } else if (this.links.length > 10000 && this.links.length < 50000) {
        return 1 / 200;
      } else {
        return 1 / 500;
      }
    },
    radius() {
      if (this.links.length < 10000) {
        return 5;
      } else {
        return 3;
      }
    }
  },

  methods: {
    // Bram this function has to be called when the apply button is pressed on the slider
    updateVisibility() {
      this.visibilityVar = 1; //Bram this 1 has to be replaced by whatever value the slider is currently on
      this.nodeLinkedEdges = { ...this.linkedByIndexUpdate };
      for (var key in this.nodeLinkedEdges) {
        if (this.nodeLinkedEdges[key].length < this.visibilityVar) {
          this.nodeLinkedEdges[key] = [];
        }
      }
      this.setVisibleEdges();
      //Also Bram, startDegree is a variable that the slider should start on
      //and maxDegree should be the maximum of the slider
    },
    tick() {
      const {
        context,
        canvas,
        transform,
        lineWidth,
        vEdges,
        nodes,
        radius,
        color,
        hoverNode
      } = this;

      context.save();

      // clear canvas
      context.clearRect(0, 0, canvas.width, canvas.height);
      context.translate(transform.x, transform.y);
      context.scale(transform.k, transform.k);

      // draw white links
      // TODO: fix drawing of edges
      context.strokeStyle = this.dark ? "white" : "grey";
      context.lineWidth = lineWidth;
      context.beginPath();
      if (vEdges) {
        vEdges.forEach(function(d) {
          context.moveTo(d.source.x, d.source.y);
          context.lineTo(d.target.x, d.target.y);
        });
      }
      context.stroke();

      // draw nodes
      nodes.forEach(d => {
        if (this.selectedNodes.includes(d.id) || hoverNode == d) {
          context.fillStyle = "red";
        } else {
          context.fillStyle = color(d.group);
        }
        context.beginPath();
        context.moveTo(d.x, d.y);
        context.arc(d.x, d.y, radius, 0, 2 * Math.PI);
        context.fill();
      });

      if (hoverNode != null) {
        context.beginPath();
        let rectHeight = 10;
        let rectWidth = hoverNode.name.length * 3;
        context.fillStyle = this.dark ? "white" : "black";
        context.rect(
          hoverNode.x - rectWidth / 2,
          hoverNode.y - 20,
          rectWidth,
          rectHeight
        );
        context.fill();
        context.beginPath();
        context.font = "5px Georgia";
        context.textAlign = "center";
        context.textBaseline = "middle";

        context.fillStyle = this.dark ? "black" : "white";
        context.fillText(
          hoverNode.name.replace(/_/g, " "),
          hoverNode.x,
          hoverNode.y - 20 + rectHeight / 2
        );
      }

      context.restore();
    },
    zoomed() {
      this.transform = d3.event.transform;
      this.tick();
    },
    dragsubject() {
      const { transform, nodes, radius } = this;

      var i,
        x = transform.invertX(d3.event.x),
        y = transform.invertY(d3.event.y),
        dx,
        dy;
      for (i = nodes.length - 1; i >= 0; --i) {
        let node = nodes[i];
        dx = x - node.x;
        dy = y - node.y;

        if (dx * dx + dy * dy < radius * radius) {
          node.x = transform.applyX(node.x);
          node.y = transform.applyY(node.y);

          return node;
        }
      }
    },
    dragstarted() {
      const { simulation, transform } = this;
      if (!d3.event.active) simulation.alphaTarget(0.3).restart();
      d3.event.subject.fx = transform.invertX(d3.event.x);
      d3.event.subject.fy = transform.invertY(d3.event.y);
    },
    dragged() {
      const { transform } = this;

      d3.event.subject.fx = transform.invertX(d3.event.x);
      d3.event.subject.fy = transform.invertY(d3.event.y);
    },
    dragended() {
      const { simulation } = this;

      if (!d3.event.active) simulation.alphaTarget(0);
      d3.event.subject.fx = null;
      d3.event.subject.fy = null;
    },

    mouseMoved() {
      if (this.getVisibleNodes().length < 50) {
        let mouseX = this.transform.invertX(d3.event.layerX);
        let mouseY = this.transform.invertY(d3.event.layerY);
        this.hoverNode = null;
        this.getVisibleNodes().forEach(d => {
          if (
            mouseX >= d.x - this.radius &&
            mouseX <= d.x + this.radius &&
            mouseY >= d.y - this.radius &&
            mouseY <= d.y + this.radius
          ) {
            this.hoverNode = d;
          }
        });
        this.tick();
      } else {
        this.hoverNode = null;
      }
    },

    getVisibleNodes() {
      const { transform } = this;

      return this.nodes.filter(
        node =>
          node.x > transform.invertX(0) &&
          node.x < transform.invertX(0 + this.canvas.width) &&
          node.y > transform.invertY(0) &&
          node.y < transform.invertY(0 + this.canvas.height)
      );
    },
    setVisibleEdges() {
      const vNodeEdges = this.getVisibleNodes()
        .map(node => this.nodeLinkedEdges[node.index])
        .flat();

      this.vEdges = this.links.filter(link =>
        vNodeEdges.includes(link.source.index)
      );
    },
    handleLassoStart() {
      this.tick();
    },

    handleLassoEnd(lassoPolygon) {
      const { transform } = this;
      lassoPolygon.forEach(function(item) {
        item[0] = transform.invertX(item[0]);
        item[1] = transform.invertY(item[1]);
      });

      let selectionNodes = this.nodes
        .filter(function(d) {
          return d3.polygonContains(lassoPolygon, [d.x, d.y]);
        })
        .map(obj => {
          return obj.id;
        });

      this.$store.commit("setSelectedNodes", selectionNodes);

      this.tick();
    }
  },

  async mounted() {
    this.canvas = this.$refs["canvas"];
    d3.select(this.canvas).on("click", () => {
      let mouseX = this.transform.invertX(d3.event.layerX);
      let mouseY = this.transform.invertY(d3.event.layerY);
      this.nodes.forEach(d => {
        if (
          mouseX >= d.x - this.radius &&
          mouseX <= d.x + this.radius &&
          mouseY >= d.y - this.radius &&
          mouseY <= d.y + this.radius
        ) {
          this.$store.commit("addSelectedNode", d.id);
        }
      });
    });
    this.context = this.canvas.getContext("2d");
    this.simulation = d3
      .forceSimulation()
      .force("link", d3.forceLink().id(d => d.id))
      .force("charge", d3.forceManyBody())
      .force("source", d3.forceX().strength(0.02))
      .force("target", d3.forceY().strength(0.02))
      .force(
        "center",
        d3.forceCenter(this.canvas.width / 2, this.canvas.height / 2)
      );

    this.selection = d3
      .select(this.canvas)
      .on("mousemove", this.mouseMoved)
      .call(
        d3
          .drag()
          .subject(this.dragsubject)
          .on("start", this.dragstarted)
          .on("drag", this.dragged)
          .on("end", this.dragended)
      )
      .call(
        d3
          .zoom()
          .scaleExtent([1 / 10, 8])
          .on("zoom", this.zoomed)
          .on("start", () => {
            this.vEdges = [];
          })
          .on("end", () => {
            this.setVisibleEdges();
            this.tick();
          })
      );
    this.lassoInstance = await lasso("#0bb", false);
    this.lassoInstance
      .on("start", this.handleLassoStart)
      .on("end", this.handleLassoEnd);

    // create key listeners for selection option
    let scope = this;
    window.addEventListener("keydown", e => {
      if (e.keyCode == 16) {
        try {
          d3.select(scope.$refs["div"])
            .append("svg")
            .style("position", "absolute")
            .style("top", 0)
            .style("left", 0)
            .attr("width", scope.canvas.width)
            .attr("height", scope.canvas.height);
          d3.select(scope.$refs["div"])
            .select("svg")
            .call(scope.lassoInstance);
        } catch (exception) {
          // wait until element is loaded
        }
      }
    });

    window.addEventListener("keyup", e => {
      if (e.keyCode == 16) {
        d3.select(scope.$refs["div"])
          .selectAll("svg")
          .remove();
      }
    });

    // add event listener
    this.simulation.nodes(this.nodes).on("tick", this.tick);

    // assign force to simulation
    this.simulation.force("link").links(this.links);

    this.nodeLinkedEdges = this.data.matrix.edges.map(i => {
      return i
        .map((j, index) => {
          if (j > 0) {
            return index;
          }
        })
        .filter(i => i);
    });

    setTimeout(() => {
      this.setVisibleEdges();
    }, 1000);

    for (var node in this.nodeLinkedEdges) {
      this.sortArray.push([node, this.nodeLinkedEdges[node]]);
    }
    this.sortArray.sort(function(a, b) {
      return a[1].length - b[1].length;
    });
    this.maxDegree = this.sortArray[this.sortArray.length - 1][1].length;

    this.linkedByIndexUpdate = { ...this.nodeLinkedEdges };

    if (this.links.length > 10000) {
      this.startDegree = this.sortArray[this.sortArray.length - 6][1].length;
    }
    for (var key in this.nodeLinkedEdges) {
      if (this.nodeLinkedEdges[key].length < this.startDegree) {
        this.nodeLinkedEdges[key] = [];
      }
    }
    this.updateVisibility();
  },

  destroyed() {
    this.selection = null;
    this.simulation.stop();
    this.simulation = null;
    this.vEdges = null;
    this.transform = null;
    this.color = null;
    this.nodeLinkedEdges = null;
    this.linkedByIndexUpdate = null;
    this.maxDegree = null;
    this.circleRadius = null;
    this.sortArray = null;
    this.startDegree = null;
  }
};
</script>
